HDF5 C++ API Reference Manual

- Main Page
- Namespaces
- Classes
- Files
- Examples

- Class List
- Class Hierarchy
- Class Members

# H5::DSetCreatPropList Class Reference

`#include <H5DcreatProp.h>`

Inheritance diagram for H5::DSetCreatPropList:

List of all members.

## Public Member Functions
| DSetCreatPropList ()
| Default constructor: creates a stub dataset creation property list.
bool | allFiltersAvail () const
| Queries whether all the filters set in this property list are available currently.
H5D_alloc_time_t | getAllocTime () const
| Get space allocation time for this property.
void | setAllocTime (H5D_alloc_time_t alloc_time) const
| Sets space allocation time for dataset during creation.
int | getChunk (int max_ndims, hsize_t *dim) const
| Retrieves the size of the chunks used to store a chunked layout dataset.
void | setChunk (int ndims, const hsize_t *dim) const
| Sets the size of the chunks used to store a chunked layout dataset.
void | getExternal (unsigned idx, size_t name_size, char *name, off_t &offset, hsize_t &size) const
| Returns information about an external file.
int | getExternalCount () const
| Returns the number of external files for a dataset.
H5D_fill_time_t | getFillTime () const
| Gets fill value writing time.
void | setFillTime (H5D_fill_time_t fill_time) const
| Sets fill value writing time for dataset.
void | getFillValue (const DataType &fvalue_type, void *value) const
| Retrieves a dataset fill value.
void | setFillValue (const DataType &fvalue_type, const void *value) const
| Sets a dataset fill value.
H5Z_filter_t | getFilter (int filter_number, unsigned int &flags, size_t &cd_nelmts, unsigned int *cd_values, size_t namelen, char name[]) const
| Returns information about a filter in a pipeline.
void | getFilterById (H5Z_filter_t filter_id, unsigned int &flags, size_t &cd_nelmts, unsigned int *cd_values, size_t namelen, char name[]) const
| Returns information about a filter in a pipeline given the filter id.
H5D_layout_t | getLayout () const
| Retrieves the layout type of this property list.
void | setLayout (H5D_layout_t layout) const
| Sets the type of storage used store the raw data for a dataset.
int | getNfilters () const
| Returns the number of filters in the pipeline.
H5D_fill_value_t | isFillValueDefined () const
| Check if fill value has been defined for this property.
void | modifyFilter (H5Z_filter_t filter_id, unsigned int flags, size_t cd_nelmts, const unsigned int cd_values[]) const
| Modifies the specified filter.
void | removeFilter (H5Z_filter_t filter_id) const
| Removes one or more filters.
void | setDeflate (int level) const
| Sets compression method and compression level.
void | setExternal (const char *name, off_t offset, hsize_t size) const
| Adds an external file to the list of external files.
void | setFilter (H5Z_filter_t filter, unsigned int flags=0, size_t cd_nelmts=0, const unsigned int cd_values[]=NULL) const
| Adds a filter to the filter pipeline.
void | setFletcher32 () const
| Sets Fletcher32 checksum of EDC for this property list.
void | setShuffle () const
| Sets method of the shuffle filter.
void | setSzip (unsigned int options_mask, unsigned int pixels_per_block) const
| Sets up for the use of the SZIP compression filter.
virtual H5std_string | fromClass () const
| DSetCreatPropList (const DSetCreatPropList &orig)
| Copy constructor: makes a copy of the original DSetCreatPropList object.
| DSetCreatPropList (const hid_t plist_id)
| Creates a DSetCreatPropList object using the id of an existing dataset creation property list.
virtual | ~DSetCreatPropList ()
| Noop destructor.
## Static Public Attributes
static const DSetCreatPropList | DEFAULT
| Constant for dataset creation default property.

## Detailed Description

Examples:

  chunks.cpp, extend_ds.cpp, and h5group.cpp.

## Constructor & Destructor Documentation

H5::DSetCreatPropList::DSetCreatPropList | ( |  | ) |

Default constructor: creates a stub dataset creation property list.

H5::DSetCreatPropList::DSetCreatPropList | ( | const DSetCreatPropList & | orig | ) |

Copy constructor: makes a copy of the original DSetCreatPropList object.

H5::DSetCreatPropList::DSetCreatPropList | ( | const hid_t | plist_id | ) |

Creates a DSetCreatPropList object using the id of an existing dataset creation property list.

H5::DSetCreatPropList::~DSetCreatPropList | ( |  | ) | `[virtual]`

Noop destructor.

## Member Function Documentation

bool H5::DSetCreatPropList::allFiltersAvail | ( |  | ) | const

Queries whether all the filters set in this property list are available currently.

Returns:
  true if all filters available, and false if one or more filters not currently available

Exceptions:

  | H5::PropListIException |

H5D_alloc_time_t H5::DSetCreatPropList::getAllocTime | ( |  | ) | const

Get space allocation time for this property.

Returns:
  Space allocation time.

Exceptions:

  | H5::PropListIException |

Description
  The values of space allocation time can be one of the followings:
  - `H5D_ALLOC_TIME_DEFAULT`
  - `H5D_ALLOC_TIME_EARLY`
  - `H5D_ALLOC_TIME_LATE`
  - `H5D_ALLOC_TIME_INCR`

void H5::DSetCreatPropList::setAllocTime | ( | H5D_alloc_time_t | alloc_time | ) | const

Sets space allocation time for dataset during creation.

Parameters:

  | alloc_time | - IN: Allocation time

Exceptions:

  | H5::PropListIException |

Description
  Valid values for space allocation time include:
  - `H5D_ALLOC_TIME_DEFAULT`
  - `H5D_ALLOC_TIME_EARLY`
  - `H5D_ALLOC_TIME_LATE`
  - `H5D_ALLOC_TIME_INCR`

int H5::DSetCreatPropList::getChunk | ( | int | max_ndims,
|  | hsize_t * | dim |
| ) |  |  | const

Retrieves the size of the chunks used to store a chunked layout dataset.

Parameters:

  | max_ndims | - IN: Size of dim array
  | dim | - OUT: Array to store the chunk dimensions

Exceptions:

  | H5::PropListIException |

Examples:
  chunks.cpp.

void H5::DSetCreatPropList::setChunk | ( | int | ndims,
|  | const hsize_t * | dim |
| ) |  |  | const

Sets the size of the chunks used to store a chunked layout dataset.

Parameters:

  | ndims | - IN: Number of dimensions of each chunk
  | dim | - IN: Array containing the size of each chunk

Exceptions:

  | H5::PropListIException |

Description
  The ndims parameter currently must have the same value as the rank of the dataset. The values of the dim array define the size of the chunks to store the dataset's raw data. As a side-effect, the layout of the dataset will be changed to `H5D_CHUNKED`, if it is not so already.

Examples:
  extend_ds.cpp, and h5group.cpp.

void H5::DSetCreatPropList::getExternal | ( | unsigned | idx,
|  | size_t | name_size,
|  | char * | name,
|  | off_t & | offset,
|  | hsize_t & | size |
| ) |  |  | const

Returns information about an external file.

Parameters:

  | idx | - IN: Index of the external file, ranges [0-(N-1)] and returned by getExternalCount()
  | name_size | - IN: Maximum length of name
  | name | - IN: Name of the external file
  | offset | - IN: Location to return an offset value
  | size | - OUT: Location to return the size of the external file data

Exceptions:

  | H5::PropListIException |

Description
  The parameter idx ranges [0..N-1] where N is returned by getExternalCount(). At most name_size characters are copied into the name array. If the external file name is longer than name_size with the null terminator, the return value is not null terminated (similar to strncpy()). If name_size is zero or name is a null pointer, the external file name will not be returned. If offset or size are null pointers then the corresponding information will not be returned.

int H5::DSetCreatPropList::getExternalCount | ( |  | ) | const

Returns the number of external files for a dataset.

Returns:
  Number of external files

Exceptions:

  | H5::PropListIException |

H5D_fill_time_t H5::DSetCreatPropList::getFillTime | ( |  | ) | const

Gets fill value writing time.

Returns:
  Fill value writing time

Exceptions:

  | H5::PropListIException |

Description
  Valid values for fill value writing time include
  - `H5D_FILL_TIME_NEVER`
  - `H5D_FILL_TIME_ALLOC`.

void H5::DSetCreatPropList::setFillTime | ( | H5D_fill_time_t | fill_time | ) | const

Sets fill value writing time for dataset.

Returns:
  Fill value writing time

Exceptions:

  | H5::PropListIException |

Description
  Valid values for fill value writing time include
  - `H5D_FILL_TIME_NEVER`
  - `H5D_FILL_TIME_ALLOC`.

void H5::DSetCreatPropList::getFillValue | ( | const DataType & | fvalue_type,
|  | void * | value |
| ) |  |  | const

Retrieves a dataset fill value.

Parameters:

  | fvalue_type | - IN: Data type for the value passed via value
  | value | - OUT: Pointer to buffer to hold the retrieved fill value

Exceptions:

  | H5::PropListIException |

Description
  The fill value is returned through value pointer and the memory is allocated by the caller. The fill value will be converted from its current data type to the specified by fvalue_type.

void H5::DSetCreatPropList::setFillValue | ( | const DataType & | fvalue_type,
|  | const void * | value |
| ) |  |  | const

Sets a dataset fill value.

Parameters:

  | fvalue_type | - IN: Data type for the value passed via value
  | value | - IN: Pointer to buffer containing the fill value

Exceptions:

  | H5::PropListIException |

Description
  The datatype may differ from that of the dataset, but it must be one that the HDF5 library is able to convert value to the dataset datatype when the dataset is created. The default fill value is 0 (zero,) which is interpreted according to the actual dataset datatype.

  For information on setting fill value, please refer to the C layer Reference Manual at: ../RM_H5P.html::Property-SetFillValue

Examples:
  extend_ds.cpp.

H5Z_filter_t H5::DSetCreatPropList::getFilter | ( | int | filter_number,
|  | unsigned int & | flags,
|  | size_t & | cd_nelmts,
|  | unsigned int * | cd_values,
|  | size_t | namelen,
|  | char | name[] |
| ) |  |  | const

Returns information about a filter in a pipeline.

Parameters:

  | filter_number | - IN: Filter to get, range [0..N-1], where N is returned by H5Pget_nfilters()
  | flags | - OUT: General properties of the filter
  | cd_nelmts | - IN/OUT: Number of elements in cd_values /Number of values defined by the filter
  | cd_values | - OUT: Array to hold the data; allocated by the user
  | namelen | - OUT: Length of name
  | name | - OUT: Name of the filter

Returns:
  Filter id

Exceptions:

  | H5::PropListIException |

Description
  Failure occurs when filter_number is out of range.

void H5::DSetCreatPropList::getFilterById | ( | H5Z_filter_t | filter_id,
|  | unsigned int & | flags,
|  | size_t & | cd_nelmts,
|  | unsigned int * | cd_values,
|  | size_t | namelen,
|  | char | name[] |
| ) |  |  | const

Returns information about a filter in a pipeline given the filter id.

Parameters:

  | filter_id | - IN: Filter to get
  | flags | - OUT: General properties of the filter
  | cd_nelmts | - IN/OUT: Number of elements in cd_values /Number of values defined by the filter
  | cd_values | - OUT: Array to hold the data; allocated by the user
  | namelen | - IN: Length of name
  | name | - OUT: Name of the filter

Exceptions:

  | H5::PropListIException |

H5D_layout_t H5::DSetCreatPropList::getLayout | ( |  | ) | const

Retrieves the layout type of this property list.

Returns:
  Layout type, which can be:
  - `H5D_COMPACT` - raw data is stored in the object header in the file.
  - `H5D_CONTIGUOUS` - raw data is stored separately from the object header in one contiguous chunk in the file.
  - `H5D_CHUNKED` - raw data is stored separately from the object header in chunks in separate locations in the file.

Exceptions:

  | H5::PropListIException |

Description

Examples:
  chunks.cpp.

void H5::DSetCreatPropList::setLayout | ( | H5D_layout_t | layout | ) | const

Sets the type of storage used store the raw data for a dataset.

Parameters:

  | layout | - IN: Type of storage layout for raw data

Exceptions:

  | H5::PropListIException |

Description
  For information on setting layout type, please refer to ../RM_H5P.html::Property-SetLayout

int H5::DSetCreatPropList::getNfilters | ( |  | ) | const

Returns the number of filters in the pipeline.

Returns:
  Number of filters

Exceptions:

  | H5::PropListIException |

H5D_fill_value_t H5::DSetCreatPropList::isFillValueDefined | ( |  | ) | const

Check if fill value has been defined for this property.

Returns:
  - `H5D_FILL_VALUE_UNDEFINED` =0,
  - `H5D_FILL_VALUE_DEFAULT` =1,
  - `H5D_FILL_VALUE_USER_DEFINED` =2

Exceptions:

  | H5::PropListIException |

void H5::DSetCreatPropList::modifyFilter | ( | H5Z_filter_t | filter_id,
|  | unsigned int | flags,
|  | size_t | cd_nelmts,
|  | const unsigned int | cd_values[] |
| ) |  |  | const

Modifies the specified filter.

Parameters:

  | filter_id | - IN: Filter to get
  | flags | - OUT: General properties of the filter
  | cd_nelmts | - IN: Number of elements in cd_values OUT: Number of values defined by the filter
  | cd_values | - OUT: Array to hold the data; allocated by the user

Exceptions:

  | H5::PropListIException |

Description
  The flags argument is a bit vector of the field: `H5Z_FLAG_OPTIONAL(0x0001)`

  If this bit is set then the filter is optional. If the filter fails during a DataSet::write() operation then the filter is just excluded from the pipeline for the chunk for which it failed; the filter will not participate in the pipeline during a DataSet::read() of the chunk. If this bit is clear and the filter fails then the entire I/O operation fails.

void H5::DSetCreatPropList::removeFilter | ( | H5Z_filter_t | filter_id | ) | const

Removes one or more filters.

Parameters:

  | filter_id | - IN: Filter to remove

Exceptions:

  | H5::PropListIException |

Description
  Deletes a filter from the dataset creation property list; deletes all filters if filter_id is `H5Z_FILTER_NONE`.

void H5::DSetCreatPropList::setDeflate | ( | int | level | ) | const

Sets compression method and compression level.

Parameters:

  | level | - IN: Compression level, should [0..9], inclusive

Exceptions:

  | H5::PropListIException |

Description
  The function sets the compression method for this property list to `H5D_COMPRESS_DEFLATE` and the compression level to level. Lower compression levels are faster but result in less compression.

Examples:
  h5group.cpp.

void H5::DSetCreatPropList::setExternal | ( | const char * | name,
|  | off_t | offset,
|  | hsize_t | size |
| ) |  |  | const

Adds an external file to the list of external files.

Parameters:

  | name | - IN: Name of the external file
  | offset | - IN: Location where the data starts in the file
  | size | - IN: Number of bytes reserved in the file for the data

Exceptions:

  | H5::PropListIException |

Description
  If a dataset is splitted across multiple files then the files should be defined in order. The total size of the dataset is the sum of the size arguments for all the external files. If the total size is larger than the size of a dataset then the dataset can be extended (provided the data space also allows the extending).

void H5::DSetCreatPropList::setFilter | ( | H5Z_filter_t | filter_id,
|  | unsigned int | flags = `0`,
|  | size_t | cd_nelmts = `0`,
|  | const unsigned int | cd_values[] = `NULL` |
| ) |  |  | const

Adds a filter to the filter pipeline.

Parameters:

  | filter_id | - IN: Filter to add
  | flags | - IN: Specifies general properties of the filter
  | cd_nelmts | - IN: Number of elements in cd_values
  | cd_values | - IN: Auxiliary data for the filter

Exceptions:

  | H5::PropListIException |

Description
  The flags argument is a bit vector of the field: `H5Z_FLAG_OPTIONAL(0x0001)`

  If this bit is set then the filter is optional. If the filter fails during a `DataSet::write()` operation then the filter is just excluded from the pipeline for the chunk for which it failed; the filter will not participate in the pipeline during a `DataSet::read()` of the chunk. If this bit is clear and the filter fails then the entire I/O operation fails.

void H5::DSetCreatPropList::setFletcher32 | ( |  | ) | const

Sets Fletcher32 checksum of EDC for this property list.

Exceptions:

  | H5::PropListIException |

void H5::DSetCreatPropList::setShuffle | ( |  | ) | const

Sets method of the shuffle filter.

Exceptions:

  | H5::PropListIException |

Description
  Please refer to the Reference Manual of `H5Pset_shuffle` for details. ../RM_H5P.html::Property-SetShuffle

void H5::DSetCreatPropList::setSzip | ( | unsigned int | options_mask,
|  | unsigned int | pixels_per_block |
| ) |  |  | const

Sets up for the use of the SZIP compression filter.

Parameters:

  | options_mask | - IN: A bit-mask conveying the desired SZIP options. Valid values are H5_SZIP_EC_OPTION_MASK and H5_SZIP_NN_OPTION_MASK.
  | pixels_per_block | - IN: Number of pixels or data elements in each data block.

Exceptions:

  | H5::PropListIException |

Description
  The associate C function sets an SZIP compression filter, H5Z_FILTER_SZIP, for a dataset. For more information about SZIP and usage, please refer to the C layer Reference Manual at: ../RM_H5P.html::Property-SetSzip

virtual H5std_string H5::DSetCreatPropList::fromClass | ( |  | ) | const`[inline, virtual]`

Reimplemented from H5::PropList.

## Member Data Documentation

const DSetCreatPropList H5::DSetCreatPropList::DEFAULT`[static]`

Constant for dataset creation default property.

Reimplemented from H5::PropList.